﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class InputManager : MonoBehaviour
{
    SelectionBoxHandler _selector;

    public List<RoomScript> _rooms;

    // Start is called before the first frame update
    void Start()
    {
        _selector = FindObjectOfType<SelectionBoxHandler>();

        Object[] rooms = FindObjectsOfType<RoomScript>();

        for(int i = 0; i < rooms.Length; i++)
        {
            RoomScript r = rooms[i] as RoomScript;
            _rooms.Add(r);
        }
    }

    // Update is called once per frame
    void Update()
    {
        if(Input.GetMouseButtonDown(0))
            _selector.SelectBegin();

        if (Input.GetMouseButtonUp(0))
            _selector.SelectEnd();

        if(Input.GetMouseButtonDown(1))
        {
            TestDetectiveCommand();
        }
    }

    void TestDetectiveCommand()
    {
        if (_selector.selectedDetectives.Count == 1)
        {
            Vector3 mousePos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
            mousePos.y = 0;
            for (int i = 0; i < _rooms.Count; i++)
            {
                //Convert mouse position on the screen to the world position in-game.
                DetectiveScript d = _selector.selectedDetectives[0].GetComponent<DetectiveScript>();

                for (int j = 0; j < _rooms[i].roomCollider.Length; j++)
                {
                    if (_rooms[i].roomCollider[j].bounds.Contains(mousePos) && d.State == 0)
                    {
                        //Search this room.
                        d.SearchRoom(_rooms[i]);
                        return;
                    }
                }
            }
        }
    }
}