﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PenelopeScript : DetectiveScript
{

    // Start is called before the first frame update
    override protected void Start()
    {
        base.Start();
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    float Ability1(float searchTime)
    {
        return searchTime / 3.0f;
    }

    float Ability2(float interrogationTime)
    {
        return interrogationTime / 2.0f;
    }

    /// <summary>
    /// Searches any room given with the detective who calls the function.
    /// </summary>
    /// <param name="r">A Reference to the room that we are attempting to search</param>
    override public void SearchRoom(RoomScript r)
    {
        //Sets up some local variables to calculate the time that the search is going to take.
        float timeToSearch, roomSize;

        //Calculates the size of the room given by public variables.
        roomSize = r.thisRoom.Dimensions.x * r.thisRoom.Dimensions.y;

        //Does the math to calculate search time.
        timeToSearch = ((110 - DetectiveStats.SearchAbility) / 10.0f) * roomSize;

        MoveToRoom(r);

        if (ab1Active)
        {
            timeToSearch = timeToSearch / 2.0f;
            ab1Active = false;
        }

        //Begins the coroutine that handles timing the search
        StartCoroutine(StartCountdown(timeToSearch, r));
    }

    /// <summary>
    /// Searches any room given with the detective who calls the function.
    /// </summary>
    /// <param name="r">A Reference to the room that we are attempting to search</param>
    override public void Interrogate(WitnessScript w)
    {
        //Sets up some local variables to calculate the time that the search is going to take.
        float timeToInterrogate;
        float score = 0;

        //Calculates the time for this detective to interrogate this witness.
        Personality det, wit;

        det = DetectiveStats.Det.Stats;
        wit = w.personality;

        if (wit.DepravedHonorableScale < 0 && det.DepravedHonorableScale < wit.DepravedHonorableScale)
            score += -1 * (det.DepravedHonorableScale - wit.DepravedHonorableScale);
        else if (wit.DepravedHonorableScale > 0 && det.DepravedHonorableScale > wit.DepravedHonorableScale)
            score += det.DepravedHonorableScale - wit.DepravedHonorableScale;
        else if (wit.DepravedHonorableScale == 0)
        {
            float temp = det.DepravedHonorableScale;
            if (det.DepravedHonorableScale < 0)
                temp *= -1;
            score += temp;
        }

        if (wit.WeakStrongScale < 0 && det.WeakStrongScale < wit.WeakStrongScale)
            score += -1 * (det.WeakStrongScale - wit.WeakStrongScale);
        else if (wit.WeakStrongScale > 0 && det.WeakStrongScale > wit.WeakStrongScale)
            score += det.WeakStrongScale - wit.WeakStrongScale;
        else if (wit.WeakStrongScale == 0)
        {
            float temp = det.WeakStrongScale;
            if (det.WeakStrongScale < 0)
                temp *= -1;
            score += temp;
        }

        if (wit.LazyAmbitiousScale < 0 && det.LazyAmbitiousScale < wit.LazyAmbitiousScale)
            score += -1 * (det.LazyAmbitiousScale - wit.LazyAmbitiousScale);
        else if (wit.LazyAmbitiousScale > 0 && det.LazyAmbitiousScale > wit.LazyAmbitiousScale)
            score += det.LazyAmbitiousScale - wit.LazyAmbitiousScale;
        else if (wit.LazyAmbitiousScale == 0)
        {
            float temp = det.LazyAmbitiousScale;
            if (det.LazyAmbitiousScale < 0)
                temp *= -1;
            score += temp;
        }

        //Does the math to calculate search time.
        timeToInterrogate = 115.0f - (score / 3.0f);

        if (ab2Active)
        {
            timeToInterrogate = timeToInterrogate / 2.0f;
            ab2Active = false;
        }

        //Begins the coroutine that handles timing the search
        StartCoroutine(StartCountdown(timeToInterrogate, w));
    }
}
