﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SelectionBoxHandler : MonoBehaviour
{
    bool _isSelecting = false;
    Vector3 _mousePosition1;

    public Material defaultMaterial;
    public Material selectedMaterial;

    public List<GameObject> selectedDetectives;
    public List<GameObject> _allDetectives;

    // Start is called before the first frame update
    void Start()
    { 
        Object[] detectives = FindObjectsOfType<DetectiveScript>();

        for(int i = 0; i < detectives.Length; i++)
        {
            DetectiveScript g = detectives[i] as DetectiveScript;
            Debug.Log(g);
            _allDetectives.Add(g.gameObject);
        }

    }

    // Update is called once per frame
    void Update()
    {

    }

    private void OnGUI()
    {
        if (_isSelecting)
        {
            // Create a rect from both mouse positions
            var rect = Utils.GetScreenRect(_mousePosition1, Input.mousePosition);
            Utils.DrawScreenRect(rect, new Color(0.8f, 0.8f, 0.95f, 0.25f));
            Utils.DrawScreenRectBorder(rect, 2, new Color(0.8f, 0.8f, 0.95f));
        }
    }

    public bool IsWithinSelectionBounds(GameObject gameObject)
    {
        if (!_isSelecting)
            return false;

        var camera = Camera.main;
        var viewportBounds = Utils.GetViewportBounds(camera, _mousePosition1, Input.mousePosition);

        return viewportBounds.Contains(camera.WorldToViewportPoint(gameObject.transform.position));
    }

    public void SelectBegin()
    {
        for (int i = 0; i < selectedDetectives.Count; i++)
        {
            selectedDetectives[i].GetComponent<Renderer>().material = defaultMaterial;
        }

        _isSelecting = true;
        selectedDetectives.Clear();
        _mousePosition1 = Input.mousePosition;
    }

    public void SelectEnd()
    {
        for (int i = 0; i < _allDetectives.Count; i++)
        {
            if (IsWithinSelectionBounds(_allDetectives[i]))
            {
                _allDetectives[i].GetComponent<Renderer>().material = selectedMaterial;
                selectedDetectives.Add(_allDetectives[i]);
            }
        }

        _isSelecting = false;
    }
}
