﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class templateTut : MonoBehaviour
{
    [SerializeField]
    [TextArea]
    protected string startText;
    [SerializeField]
    [TextArea]
    protected string endText;
    public TStatus eventSetting = TStatus.NotStarted;
    protected TutorialManager tutorialManager;
    [SerializeField]
    private templateTut nextEvent;

    private void Start()
    {
        //attach the tutorial manager to each of the tutorials
        tutorialManager = gameObject.GetComponent<TutorialManager>();
    }
    private void FixedUpdate()
    {
        if(eventSetting == TStatus.Started)
        {
            startTutorial();
        }
        if(eventSetting == TStatus.Completing)
        {
            endTutorial();
        }
        if(eventSetting == TStatus.Completed)
        {
            nextEvent.eventSetting = TStatus.Started;
            eventSetting = TStatus.Redundant;
        }
    }
    protected void startTutorial()
    {
        tutorialManager.displayTutorial(startText);
    }

    protected void endTutorial()
    {
        tutorialManager.displayTutorial(endText);
    }
}
